
//+------------------------------------------------------------------+
//|                                                    SAP - Adx.mq4 |
//|                                                                  |
//| This system (SAP System Basic I) is still under development,     |
//| there will be SAP Basic II, SAP Basic III and SAP Advance.       |
//| All systems are for sale but you can pay as much as              |
//| you feel like it or download it for free.                        |
//| If you find "SAP System Basic I" is useful for your trading,     |
//| care to donate to one of my accounts below.                      |
//| So that I can continue to develop this system.                   |                      
//|                                                                  |
//| 1. Liberty Reserve                                               |
//|    account U4821741 - Adhi Nugroho                               |
//| 2. C-Gold                                                        |
//|    account 38058 - Adhi Nugroho                                  | 
//| 3. Standard Chartered Bank Indonesia - SCB Semarang              |
//|    acc : 02105169524 - Adhi Nugroho                              |
//|    local : bisa lewat atm / internet banking , any bank          |
//|    international :                                               |
//|    swift - SCBLIDJX ; iban - AE950440002602105169524             |
//|------------------------------------------------------------------|    
//| Kalau system SAP bermanfaat, silahkan membayar selayaknya        |
//| ke salah satu rekening di atas atau menggunakannya secara gratis.|
//|                                                                  |            
//| Terima kasih . May the pips be with you .                        |
//| email : odessa.xyz.2005@gmail.com                                |
//|                                                                  |
//| (Special thank you to the original creator of this indicator)    |
//+------------------------------------------------------------------+

#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DimGray  
#property indicator_color2  White 
#property indicator_color3  White 
#property indicator_color4  Blue
#property indicator_color5  Blue 
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2


extern string TimeFrame      = "Current time frame";
extern double AdxPeriod   = 2;
extern int    AdxPrice    = PRICE_MEDIAN;
extern bool   TrendMode      = true;
extern bool   MultiColorMode = true;
extern bool   Interpolate    = true;

double adxma[];
double adxua[];
double adxub[];
double adxda[];
double adxdb[];
double trend[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,adxma);
   SetIndexBuffer(1,adxua);
   SetIndexBuffer(2,adxub);
   SetIndexBuffer(3,adxda);
   SetIndexBuffer(4,adxdb);
   SetIndexBuffer(5,trend);

      AdxPeriod         = MathMax(AdxPeriod,1);
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

 
   IndicatorShortName(timeFrameToString(timeFrame)+" SAP - Adx ("+DoubleToStr(AdxPeriod,2)+")");
   SAPSystem();
   return(0);
}
 

double  work[][6];
#define prc 0
#define pdm 1
#define mdm 2
#define pdi 3
#define mdi 4
#define out 5


int start()
{
   int counted_bars = IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { adxma[0] = limit+1; return(0); }

   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      if (!calculateValue && MultiColorMode && trend[limit]== 1) CleanPoint(limit,adxua,adxub);
      if (!calculateValue && MultiColorMode && trend[limit]==-1) CleanPoint(limit,adxda,adxdb);
      
      
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         work[r][prc] = NormalizeDouble(iMA(NULL,0,1,0,MODE_SMA,AdxPrice,i),4);

 
         double diff = work[r][prc]-work[r-1][prc];
         double tpdm = 0;
         double tmdm = 0;
               if (diff>0)
                     tpdm =  diff;
               else  tmdm = -diff;          
         work[r][pdm] = ((AdxPeriod-1.0)*work[r-1][pdm]+tpdm)/AdxPeriod;
         work[r][mdm] = ((AdxPeriod-1.0)*work[r-1][mdm]+tmdm)/AdxPeriod;


         double trueRange = work[r][pdm]+work[r][mdm];
         double tpdi      = 0;
         double tmdi      = 0;
               if (trueRange>0)
               {
                  tpdi = work[r][pdm]/trueRange;
                  tmdi = work[r][mdm]/trueRange;
               }            
         work[r][pdi] = ((AdxPeriod-1.0)*work[r-1][pdi]+tpdi)/AdxPeriod;
         work[r][mdi] = ((AdxPeriod-1.0)*work[r-1][mdi]+tmdi)/AdxPeriod;
   
                  
         double tout  = 0; if ((work[r][pdi]+work[r][mdi])>0) tout = MathAbs(work[r][pdi]-work[r][mdi])/(work[r][pdi]+work[r][mdi]);
         work[r][out] = ((AdxPeriod-1.0)*work[r-1][out]+tout)/AdxPeriod;

     
         double thi = MathMax(work[r][out],work[r-1][out]);
         double tlo = MathMin(work[r][out],work[r-1][out]);
            for (int j = 2; j<AdxPeriod; j++)
            {
               thi = MathMax(work[r-j][out],thi);
               tlo = MathMin(work[r-j][out],tlo);
            }            
         double vi = 0; if ((thi-tlo)>0) vi = (work[r][out]-tlo)/(thi-tlo);

         
         adxma[i]  = ((AdxPeriod-vi)*adxma[i+1]+vi*work[r][prc])/AdxPeriod;
         adxua[i] = EMPTY_VALUE;
         adxub[i] = EMPTY_VALUE;
         adxda[i] = EMPTY_VALUE;
         adxdb[i] = EMPTY_VALUE;

            if (TrendMode)
                  trend[i] = trend[i+1];
            else  trend[i] = 0;
            if (adxma[i]>adxma[i+1]) trend[i] =  1;
            if (adxma[i]<adxma[i+1]) trend[i] = -1;
            if (!calculateValue && MultiColorMode && trend[i]== 1) PlotPoint(i,adxua,adxub,adxma);
            if (!calculateValue && MultiColorMode && trend[i]==-1) PlotPoint(i,adxda,adxdb,adxma);
      }
      return(0);
   }
   
   
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColorMode && trend[limit]== 1) CleanPoint(limit,adxua,adxub);
   if (MultiColorMode && trend[limit]==-1) CleanPoint(limit,adxda,adxdb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         adxma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",AdxPeriod,AdxPrice,TrendMode,0,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",AdxPeriod,AdxPrice,TrendMode,5,y);
         adxua[i] = EMPTY_VALUE;
         adxub[i] = EMPTY_VALUE;
         adxda[i] = EMPTY_VALUE;
         adxdb[i] = EMPTY_VALUE;

  
      
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

 
         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
               adxma[i+k] = adxma[i] + (adxma[i+n]-adxma[i])*k/n;
   }
   for (i=limit;i>=0;i--)
   {
      if (MultiColorMode && trend[i]== 1) PlotPoint(i,adxua,adxub,adxma);
      if (MultiColorMode && trend[i]==-1) PlotPoint(i,adxda,adxdb,adxma);
   }

   return(0);
         
}

//+------------------------------------------------------------------+
//|                                                    SAP - Adx.mq4 |
//|                                                                  |
//| This system (SAP System Basic I) is still under development,     |
//| there will be SAP Basic II, SAP Basic III and SAP Advance.       |
//| All systems are for sale but you can pay as much as              |
//| you feel like it or download it for free.                        |
//| If you find "SAP System Basic I" is useful for your trading,     |
//| care to donate to one of my accounts below.                      |
//| So that I can continue to develop this system.                   |                      
//|                                                                  |
//| 1. Liberty Reserve                                               |
//|    account U4821741 - Adhi Nugroho                               |
//| 2. C-Gold                                                        |
//|    account 38058 - Adhi Nugroho                                  | 
//| 3. Standard Chartered Bank Indonesia - SCB Semarang              |
//|    acc : 02105169524 - Adhi Nugroho                              |
//|    local : bisa lewat atm / internet banking , any bank          |
//|    international :                                               |
//|    swift - SCBLIDJX ; iban - AE950440002602105169524             |
//|------------------------------------------------------------------|    
//| Kalau system SAP bermanfaat, silahkan membayar selayaknya        |
//| ke salah satu rekening di atas atau menggunakannya secara gratis.|
//|                                                                  |            
//| Terima kasih . May the pips be with you .                        |
//| email : odessa.xyz.2005@gmail.com                                |
//|                                                                  |
//| (Special thank you to the original creator of this indicator)    |
//+------------------------------------------------------------------+

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}


void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}



string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};


int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
void SAPSystem() {
   ObjectCreate("SAP System Basic I", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("SAP System Basic I", "SAP System", 12, "Arial", White);
   ObjectSet("SAP System Basic I", OBJPROP_CORNER, 2);
   ObjectSet("SAP System Basic I", OBJPROP_XDISTANCE, 5);
   ObjectSet("SAP System Basic I", OBJPROP_YDISTANCE, 10);
   }

//+------------------------------------------------------------------+
//|                                                    SAP - Adx.mq4 |
//|                                                                  |
//| This system (SAP System Basic I) is still under development,     |
//| there will be SAP Basic II, SAP Basic III and SAP Advance.       |
//| All systems are for sale but you can pay as much as              |
//| you feel like it or download it for free.                        |
//| If you find "SAP System Basic I" is useful for your trading,     |
//| care to donate to one of my accounts below.                      |
//| So that I can continue to develop this system.                   |                      
//|                                                                  |
//| 1. Liberty Reserve                                               |
//|    account U4821741 - Adhi Nugroho                               |
//| 2. C-Gold                                                        |
//|    account 38058 - Adhi Nugroho                                  | 
//| 3. Standard Chartered Bank Indonesia - SCB Semarang              |
//|    acc : 02105169524 - Adhi Nugroho                              |
//|    local : bisa lewat atm / internet banking , any bank          |
//|    international :                                               |
//|    swift - SCBLIDJX ; iban - AE950440002602105169524             |
//|------------------------------------------------------------------|    
//| Kalau system SAP bermanfaat, silahkan membayar selayaknya        |
//| ke salah satu rekening di atas atau menggunakannya secara gratis.|
//|                                                                  |            
//| Terima kasih . May the pips be with you .                        |
//| email : odessa.xyz.2005@gmail.com                                |
//|                                                                  |
//| (Special thank you to the original creator of this indicator)    |
//+------------------------------------------------------------------+